/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH375 **
**  TC2.0@PC, ADS_C_1.2@ARM           **
****************************************
*/
/* CH375 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* ARMƬCԵUļдʾ */
/* óUе/C51/CH375HFT.CļеСдĸתɴдĸ, д½ļNEWFILE.TXT,
   ҲԭļCH375HFT.C, ôóʾC51Ŀ¼CH375ͷļ, ½NEWFILE.TXTļдʾϢ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ, ½NEWFILE.TXTļдʾϢ
*/
/* CH375INT#Ųòѯʽ, ݸƷʽΪ"ڲ", Philips LPC2114Ƭ, 0Ϣ,9600bps */
/* ENDIAN = "little" */

/* ARMCC -c -asm -o CH375HF9.O CH375HF9.C -ISRC\ */
/* ARMLINK -o CH375HFT.AXF -scatter SRC\LPC2114.SCF -entry 0 CH375HFT.O SRC\STARTUP.O SRC\HEAP.O SRC\STACK.O CH375HF9.LIB */
/* FROMELF -bin -o CH375HFT.BIN CH375HFT.AXF */

#include "TARGET.C"						/* Ŀרóʼ */

#include <string.h>
#include <stdio.h>

/* ¶ϸ˵뿴CH375HF9.Hļ */
#define LIB_CFG_FILE_IO			1		/* ļдݵĸƷʽ,0Ϊ"ⲿӳ",1Ϊ"ڲ" */
#define LIB_CFG_INT_EN			0		/* CH375INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

/* ƬRAM,CH375ӳ512ֽ,ʣRAMֿļд */
#define DISK_BASE_BUF_LEN		4096	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
#define FILE_DATA_BUF_LEN		0x2000	/* ⲿRAMļݻ,ȲСһζдݳ */
/* ׼ʹ˫д,ôҪFILE_DATA_BUF_LEN,ڲַָ,CH375FileReadXCH375FileRead,CH375FileWriteXCH375FileWrite */

#define CH375_INT_WIRE			( IO0PIN & 0x08 )	/* P0.3, CH375жINT#,CH375INT#,ڲѯж״̬ */

#define NO_DEFAULT_CH375_F_ENUM		1		/* δCH375FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH375_F_QUERY	1		/* δCH375FileQueryʽֹԽԼ */

#include "..\CH375HF9.H"

/* ЩARMƬṩϵͳ,ôֱӽCH375ϵͳ,8λI/Oʽжд */
/* ʹõLPC2114ϵͳ,I/OģCH375Ĳڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸3ڶдӳ) */
/* LPC2114Ƭ    CH375оƬ
         P0.3                 INT#
         P0.4                 A0
         P0.7                 CS#
         P0.6                 WR#
         P0.5                 RD#
  P0.15-P0.8(8λ˿)         D7-D0       */

void mDelay1_2uS( )  /* ʱ1.2uS,ݵƬƵ */
{
	UINT32	i;
	for ( i = 20; i != 0; i -- );  /* ģI/Oֻʱ */
}

void CH375_PORT_INIT( )  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
{
	IO0SET |= 0x000000E0;  /* CS,WR,RDĬΪߵƽ */
	IO0DIR &= 0xFFFF00F7;  /* 8λںINT#Ϊ */
	IO0DIR |= 0x000000F0;  /* CS,WR,RD,A0Ϊ */
}

void xWriteCH375Cmd( UINT8 mCmd )		/* ⲿıCH375õӳ,CH375д */
{
	mDelay1_2uS( ); mDelay1_2uS( );  /* ʱ1uS */
	IO0CLR |= 0x0000FF00;  /* 岢 */
	IO0SET |= ( (UINT32)mCmd << 8 ) | 0x00000010;  /* CH375Ĳ, A0(P0.4)=1; */
	IO0DIR |= 0x0000FFF0;  /* д, CS,WR,RD,A0Ϊ */
	IO0CLR |= 0x000000C0;  /* Чдź, дCH375оƬ˿, A0(P0.4)=1; CS(P0.7)=0; WR=(P0.6)=0; RD(P0.5)=1; */
	IO0DIR = IO0DIR; IO0DIR = IO0DIR;  /* ò,ʱ,CH375Ҫдȴ100nS */
	IO0SET |= 0x000000E0;  /* ЧĿź, ɲCH375оƬ, A0(P0.4)=1; CS(P0.7)=1; WR=(P0.6)=1; RD(P0.5)=1; */
	IO0CLR |= 0x00000010;  /* A0(P0.4)=0; ѡ */
	IO0DIR &= 0xFFFF00FF;  /* ֹ */
	mDelay1_2uS( ); mDelay1_2uS( );  /* ʱ2uS */
}

void xWriteCH375Data( UINT8 mData )		/* ⲿıCH375õӳ,CH375д */
{
	IO0CLR |= 0x0000FF00;  /* 岢 */
	IO0SET |= (UINT32)mData << 8;  /* CH375Ĳ */
	IO0DIR |= 0x0000FF00;  /* д */
	IO0CLR |= 0x000000D0;  /* Чдź, дCH375оƬݶ˿, A0(P0.4)=0; CS(P0.7)=0; WR=(P0.6)=0; RD(P0.5)=1; */
	IO0DIR = IO0DIR; IO0DIR = IO0DIR;  /* ò,ʱ,CH375Ҫдȴ100nS */
	IO0SET |= 0x000000E0;  /* ЧĿź, ɲCH375оƬ, A0(P0.4)=0; CS(P0.7)=1; WR=(P0.6)=1; RD(P0.5)=1; */
	IO0DIR &= 0xFFFF00FF;  /* ֹ */
	mDelay1_2uS( );  /* ʱ1.2uS */
}

UINT8 xReadCH375Data( void )			/* ⲿıCH375õӳ,CH375 */
{
	UINT8	mData;
	mDelay1_2uS( );  /* ʱ1.2uS */
	IO0DIR &= 0xFFFF00FF;  /*  */
	IO0CLR |= 0x000000B0;  /* Чź, CH375оƬݶ˿, A0(P0.4)=0; CS(P0.7)=0; WR=(P0.6)=1; RD(P0.5)=0; */
	IO0DIR = IO0DIR; IO0DIR = IO0DIR;  /* ò,ʱ,CH375Ҫдȴ100nS */
	mData = (UINT8)( IO0PIN >> 8 );  /* CH375ĲP0.15-P0.8 */
	IO0SET |= 0x000000E0;  /* ЧĿź, ɲCH375оƬ, A0(P0.4)=0; CS(P0.7)=1; WR=(P0.6)=1; RD(P0.5)=1; */
	return( mData );
}

/* P0.2һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )		{ IO0DIR |= 0x04; }	/* P0.2 ߵƽΪ */
#define LED_OUT_ACT( )		{ IO0CLR |= 0x04; }	/* P0.2 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ IO0SET |= 0x04; }	/* P0.2 ͵ƽLEDʾ */

/* ʱָʱ,ݵƬƵ,ȷ */
void	mDelaymS( UINT32 ms )
{
	UINT32	i;
	while ( ms -- ) for ( i = 25000; i != 0; i -- );
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	_printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		mDelaymS( 100 );
		LED_OUT_INACT( );
		mDelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	UINT32	x;
	PINSEL0 = PINSEL0 & 0xFFFFFFF0 | 0x00000005;  // I/OӵUART0
	U0LCR = 0x80;                    // DLABλ1
	x = (Fpclk>>4)/9600;             // 9600bps
	U0DLM = x>>8;
	U0DLL = x&0xff;
	U0LCR = 0x03;                    // 8λλ,1λֹͣλ,żУ
	U0FCR = 0x01;
}

/* ͨϢ */
int		fputc( int c, FILE *f )
{
	U0THR = c;                            // 
	while( ( U0LSR & 0x20 ) == 0 );       // ȴݷ
	return( c );
}

int		main( ) {
	UINT8	i, c, SecCount;
	UINT16	NewSize, count;  /* ΪRAM,NewSizeΪ16λ,ʵļϴ,Ӧ÷ּζдҽNewSizeΪUINT32Աۼ */
	UINT8	*pCodeStr;
	CH375_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	mDelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH375רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH375LibInit( );  /* ʼCH375CH375оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
//		while ( CH375DiskStatus != DISK_CONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴU̲ */
		while ( CH375DiskStatus < DISK_CONNECT ) {  /* ѯCH375жϲж״̬,ȴU̲ */
			if ( CH375DiskConnect( ) == ERR_SUCCESS ) break;  /* 豸򷵻سɹ,CH375DiskConnectͬʱȫֱCH375DiskStatus */
			mDelaymS( 100 );
		}
		LED_OUT_ACT( );  /* LED */
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
			mDelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH375DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH375vSectorSize ) {  /* ݻǷ㹻,CH375vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			while ( CH375DiskConnect( ) == ERR_SUCCESS ) mDelaymS( 100 );
			continue;
		}
#endif
/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH375DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * (CH375vSectorSize/512) / 2048 ) );  // ʾΪMBΪλ
		// ԭ㷽 (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * CH375vSectorSize / 1000000 ) пǰ˺, ޸ĳʽ
*/

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "\\C51\\CH375HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH375FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = (UINT8 *)"\\*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = (UINT8 *)"\\C51\\CH375*";  /* CH375HFT.Cļг\C51Ŀ¼µCH375ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 254; c ++ ) {  /* ǰ254ļ */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
				i = strlen( (char const *)mCmdParam.Open.mPathName );  /* ļ,Դļ */
/* һöٷǣ˴cΪ0xFFȻöŴCH375vFileSizeУӶ254ļ02147483647 */
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0254 */
				i = CH375FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
			pCodeStr = (UINT8 *)"Ҳ/C51/CH375HFT.Cļ\xd\n";
			for ( i = 0; i != 255; i ++ ) {
				if ( ( FILE_DATA_BUF[i] = *pCodeStr ) == 0 ) break;
				pCodeStr++;
			}
			NewSize = i;  /* ļĳ */
			SecCount = 1;  /* (NewSize+CH375vSectorSize-1)/CH375vSectorSize, ļ,ΪдΪλ */
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
/*			printf( "Query\n" );
			i = CH375FileQuery( );  ѯǰļϢ
			mStopIfError( i );*/
			printf( "Read\n" );
			if ( CH375vFileSize > FILE_DATA_BUF_LEN ) {  /* ʾõ62256ֻ32Kֽ,CH375ӳ512ֽ,ֻȡ63,Ҳǲ32256ֽ */
				SecCount = FILE_DATA_BUF_LEN / CH375vSectorSize;  /* ʾõ62256ֻ32Kֽ,CH375ӳ512ֽ,ֻȡ63,Ҳǲ32256ֽ */
				NewSize = FILE_DATA_BUF_LEN;  /* RAMƳ */
			}
			else {  /* ԭļС,ôʹԭ */
				SecCount = ( CH375vFileSize + CH375vSectorSize-1 ) / CH375vSectorSize;  /* ļ,ΪдΪλ,ȼCH375vSectorSize-1Ϊ˶ļβ1Ĳ */
				NewSize = (UINT16)CH375vFileSize;  /* ԭļĳ */
			}
			printf( "Size=%ld, Len=%d, Sec=%d\n", CH375vFileSize, NewSize, (UINT16)SecCount );
			mCmdParam.Read.mSectorCount = SecCount;  /* ȡȫ,60ֻȡ60 */
/*			current_buffer = & FILE_DATA_BUF[0];  ļдݵĸƷʽΪ"ⲿӳ",ôҪôݵĻʼַ */
			CH375vFileSize += CH375vSectorSize-1;  /* Ĭ,ʽȡʱ,޷ļβ1Ĳ,ԱʱӴļԶȡβͷ */
			i = CH375FileRead( );  /* ļȡ */
			CH375vFileSize -= CH375vSectorSize-1;  /* ָԭļ */
			mStopIfError( i );
/*
		ļȽϴ,һζ,ٵCH375FileReadȡ,ļָԶƶ
		while ( 1 ) {
			c = 32;   ÿζȡ32
			mCmdParam.Read.mSectorCount = c;   ָȡ
			CH375FileRead();   ļָԶ
			
			if ( mCmdParam.Read.mSectorCount < c ) break;   ʵʶС˵ļѾ
		}

	    ϣָλÿʼд,ƶļָ
		mCmdParam.Locate.mSectorOffset = 3;  ļǰ3ʼд
		i = CH375FileLocate( );
		mCmdParam.Read.mSectorCount = 10;
		CH375FileRead();   ֱӶȡļĵ(CH375vSectorSize*3)ֽڿʼ,ǰ3

	    ϣӵԭļβ,ƶļָ
		i = CH375FileOpen( );
		mCmdParam.Locate.mSectorOffset = 0xffffffff;  Ƶļβ,Ϊλ,ԭļ3ֽ,CH375vSectorSizeֽڿʼ
		i = CH375FileLocate( );
		mCmdParam.Write.mSectorCount = 10;
		CH375FileWrite();   ԭļĺ

ʹCH375FileReadXжݻʼַ
		mCmdParam.ReadX.mSectorCount = 2;
		mCmdParam.ReadX.mDataBuffer = 0x2000;  ݷŵ2000HʼĻ
		CH375FileReadX();   ļжȡ2ָ

ʹCH375FileWriteXжݻʼַ
		mCmdParam.WiiteX.mSectorCount = 2;
		mCmdParam.WriteX.mDataBuffer = 0x4600;  4600HʼĻед
		CH375FileWriteX();   ָед2ļ
*/
			printf( "Close\n" );
			i = CH375FileClose( );  /* رļ */
			mStopIfError( i );

			i = FILE_DATA_BUF[100];
			FILE_DATA_BUF[100] = 0;  /* ַ־,ʾ100ַ */
			printf( "Line 1: %s\n", FILE_DATA_BUF );
			FILE_DATA_BUF[100] = i;  /* ָԭַ */
			for ( count=0; count < NewSize; count ++ ) {  /* ļеСдַתΪд */
				c = FILE_DATA_BUF[ count ];
				if ( c >= 'a' && c <= 'z' ) FILE_DATA_BUF[ count ] = c - ( 'a' - 'A' );
			}
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "\\NEWFILE.TXT" );  /* ļ,ڸĿ¼ */
		i = CH375FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		mCmdParam.Write.mSectorCount = SecCount;  /* д */
/*		current_buffer = & FILE_DATA_BUF[0];  ļдݵĸƷʽΪ"ⲿӳ",ôҪôݵĻʼַ */
		i = CH375FileWrite( );  /* ļд */
		mStopIfError( i );
		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;  /* : µļ,Ϊ0FFH޸ */
		mCmdParam.Modify.mFileTime = 0xffff;  /* : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ */
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  /* : µļ: 2004.05.18 */
		mCmdParam.Modify.mFileSize = NewSize;  /* : ԭļС,ôµļԭļһ,RAM,ļȴ64KB,ôNewSizeΪUINT32 */
		i = CH375FileModify( );  /* ޸ĵǰļϢ,޸ںͳ */
		mStopIfError( i );
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 0;  /* ҪԶļ,Զ,ôóCH375vSectorSizeı */
		i = CH375FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "\\OLD" );  ɾļ,ڸĿ¼
		i = CH375FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH375DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
//		while ( CH375DiskStatus != DISK_DISCONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴṴγ */
		while ( CH375DiskStatus >= DISK_CONNECT ) {  /* ѯCH375жϲж״̬,ȴṴγ */
			if ( CH375DiskConnect( ) != ERR_SUCCESS ) break;
			mDelaymS( 100 );
		}
		LED_OUT_INACT( );  /* LED */
		mDelaymS( 200 );
	}
}
