/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH375 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH375 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ */
/* MCS51Ƭ
   1. MCS51Ƭ,С0.3uS,ڻΪ12ʱʱʱƵʴ40MHz
   2. MCS51Ƭ,ͨI/Oģ8λ߶д,CH375֮ò
   3. ƬCH375֮ô
*/
/* ʾADCģɼݱ浽UļMY_ADC.TXT */
/* CH375INT#Ųòѯʽ,ͨI/Oģ8λ߶д,ͬʱṩʾ,
   ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */


/* C51   CH375HFT.C */
/* LX51  CH375HFT.OBJ , CH375HFC.LIB */
/* OHX51 CH375HFT */

#include <reg52.h>
#include <stdio.h>

#define	MAX_BYTE_IO				35		/* ֽΪλζдļʱ󳤶,Ĭֵ29,ֵռڴ,ֵС򳬹óȱֶζд */

/* ¶ϸ˵뿴CH375HFC.Hļ */
#define LIB_CFG_FILE_IO			1		/* ļдݵĸƷʽ,0Ϊ"ⲿӳ",1Ϊ"ڲ" */
#define LIB_CFG_INT_EN			0		/* CH375INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */
/*#define LIB_CFG_UPD_SIZE		1*/		/* ݺǷԶļ: 0Ϊ"",1Ϊ"Զ" */
/* Ĭ,/ֽΪ0ôCH375FileWrite/CH375ByteWriteֻдݶ޸ļ,
   ҪÿдݺԶ޸/ļ,ôʹȫֱCH375LibConfigλ4Ϊ1,
   ʱ䲻дӦøļ,ֹͻȻϵǰдļȲ,
   ȷͻȻϵߺܿݲд򲻱ظļ,ٶȲU(Uڲڴ,Ƶд) */

/* ֻʹõƬõ1KBⲿRAM: 0000H-01FFH Ϊ̶д, ֽΪλдļҪļݶдFILE_DATA_BUF */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */
//#define FILE_DATA_BUF_ADDR		0x0000	/* ⲿRAMļݻʼַ,ȲСһζдݳ,ֽģʽøû */
/* ڵƬõⲿRAMֻ1KB, ЩƬҪȥ256ֽڲRAM, ֻʣ768ֽڵⲿRAM, ǰ512ֽCH375ӳڴݻ */
//#define FILE_DATA_BUF_LEN		0x0200	/* ⲿRAMļݻ,ȲСһζдݳ,ֽģʽøû */
/* ׼ʹ˫д,ôҪFILE_DATA_BUF_LEN,ڲַָ,CH375FileReadXCH375FileRead,CH375FileWriteXCH375FileWrite */

#define CH375_INT_WIRE			INT0	/* P3.2, INT0, CH375жINT#,CH375INT#,ڲѯж״̬ */

#define NO_DEFAULT_CH375_F_ENUM		1		/* δCH375FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH375_F_QUERY	1		/* δCH375FileQueryʽֹԽԼ */

#include "..\CH375HFC.H"

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* I/OģCH375Ĳڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸3ڶдӳ) */
/* Ƭ    CH375оƬ
      P3.2                 INT#
      P1.0                 A0
      P1.1                 CS#    ģĲֻCH375,ôCS#ֱӽӵ͵ƽ,ǿƬѡ
      P1.2                 WR#
      P1.3                 RD#
      P0(8λ˿)         D7-D0       */
sbit	CH375_A0	=	P1^0;
sbit	CH375_CS	=	P1^1;
sbit	CH375_WR	=	P1^2;
sbit	CH375_RD	=	P1^3;

void mDelay1_2uS( )  /* ʱ1.2uS,ݵƬƵ */
{
	return;
}

void CH375_PORT_INIT( )  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
{
	CH375_CS = 1;
	CH375_WR = 1;
	CH375_RD = 1;
	CH375_A0 = 0;
	P0 = 0xFF;  /*  */
}

void xWriteCH375Cmd( UINT8 mCmd )		/* ⲿıCH375õӳ,CH375д */
{
//*(UINT8XV *)0XBDF1 = mCmd;
//return;
	mDelay1_2uS( ); mDelay1_2uS( );  /* ʱ1uS */
	P0 = mCmd;  /* CH375Ĳ */
	CH375_A0 = 1;
	CH375_CS = 0;
	CH375_WR = 0;  /* Чдź, дCH375оƬ˿ */
	CH375_CS = 0;  /* ò,ʱ,CH375Ҫдȴ100nS */
	CH375_WR = 1;  /* ЧĿź, ɲCH375оƬ */
	CH375_CS = 1;
	CH375_A0 = 0;
	P0 = 0xFF;  /* ֹ */
	mDelay1_2uS( ); mDelay1_2uS( );  /* ʱ2uS */
}

void xWriteCH375Data( UINT8 mData )		/* ⲿıCH375õӳ,CH375д */
{
//*(UINT8XV *)0XBCF0 = mData;
//return;
	P0 = mData;  /* CH375Ĳ */
	CH375_A0 = 0;
	CH375_CS = 0;
	CH375_WR = 0;  /* Чдź, дCH375оƬݶ˿ */
	CH375_CS = 0;  /* ò,ʱ,CH375Ҫдȴ100nS */
	CH375_WR = 1;  /* ЧĿź, ɲCH375оƬ */
	CH375_CS = 1;
	P0 = 0xFF;  /* ֹ */
	mDelay1_2uS( );  /* ʱ1.2uS */
}

UINT8 xReadCH375Data( void )			/* ⲿıCH375õӳ,CH375 */
{
	UINT8	mData;
//return( *(UINT8XV *)0XBCF0 );
	mDelay1_2uS( );  /* ʱ1.2uS */
	P0 = 0xFF;  /*  */
	CH375_A0 = 0;
	CH375_CS = 0;
	CH375_RD = 0;  /* Чдź, CH375оƬݶ˿ */
	CH375_CS = 0;  /* ò,ʱ,CH375Ҫдȴ100nS */
	mData = P0;  /* CH375Ĳ */
	CH375_RD = 1;  /* ЧĿź, ɲCH375оƬ */
	CH375_CS = 1;
	return( mData );
}

/* ƬCH375Ǵ,ôοӳ
void CH375_PORT_INIT( ) {
	SCON = 0xD0;  ôΪ9λ
òʺڲ
}

void xWriteCH375Cmd( UINT8 mCmd ) {
	TI = 0;
	TB8 = 1;
	SBUF = mCmd;
	while ( TI == 0 );
}

void xWriteCH375Data( UINT8 mData ) {
	TI = 0;
	TB8 = 0;
	SBUF = mData;
	while ( TI == 0 );
}

UINT8 xReadCH375Data( void ) {
	while ( RI == 0 );
	RI = 0;
	return( SBUF );
}
*/

/* ԺΪλʱ,ȷ,24MHzʱ */
void	mDelaymS( UINT8 delay )
{
	unsigned char	i, j, c;
	for ( i = delay; i != 0; i -- ) {
		for ( j = 200; j != 0; j -- ) c += 3;  /* 24MHzʱʱ500uS */
		for ( j = 200; j != 0; j -- ) c += 3;  /* 24MHzʱʱ500uS */
	}
}

/* ռַƵⲿRAM,ַ */
UINT8	mCopyCodeStringToXRAM( UINT8 xdata *iDestination, UINT8 code *iSource )
{
	UINT8	i = 0;
	while ( *iDestination = *iSource ) {
		iDestination ++;
		iSource ++;
		i ++;
	}
	return( i );
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		mDelaymS( 100 );
		LED_OUT_INACT( );
		mDelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x20;
	TH1 = 0xf3;  /* 24MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

main( ) {
	UINT8	i, month, hour;
	UINT16	date, adc, len;
	CH375_PORT_INIT( );  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	mDelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	i = CH375LibInit( );  /* ʼCH375CH375оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( CH375DiskStatus != DISK_CONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴU̲ */
		LED_OUT_ACT( );  /* LED */
		mDelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
			mDelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH375DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH375DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %d MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec >> 11 ) );  ʾΪMBΪλ
*/
		LED_RUN_ACT( );  /* ʼU */

/* MY_ADC.TXTļѾݵβ,½ļ */
		printf( "Open\n" );
		mCopyCodeStringToXRAM( mCmdParam.Open.mPathName, "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼ */
		i = CH375FileOpen( );  /* ļ */
		if ( i == ERR_SUCCESS ) {  /* ļڲѾ,ƶļָ뵽βԱ */
			printf( "File size = %ld\n", CH375vFileSize );  /* V1.5ӳڳɹļ,ȫֱCH375vFileSizeļǰ */
			printf( "Locate tail\n" );
			mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  /* Ƶļβ */
			i = CH375ByteLocate( );
			mStopIfError( i );
		}
		else if ( i == ERR_MISS_FILE ) {  /* ûҵļ,½ļ */
			LED_WR_ACT( );  /* д */
			printf( "Create\n" );
//			mCopyCodeStringToXRAM( mCmdParam.Create.mPathName, "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼,ղѾṩCH375FileOpen */
			i = CH375FileCreate( );  /* ½ļ,ļѾɾ½ */
			mStopIfError( i );
		}
		else mStopIfError( i );  /* ļʱ */
		LED_WR_ACT( );  /* д */
		printf( "Write begin\n" );
		i = sprintf( mCmdParam.ByteWrite.mByteBuffer, "ǰļ= %ld ֽ\xd\xa", CH375vFileSize );
		mCmdParam.ByteWrite.mByteCount = i;  /* ָдֽ,ζдĳȲܳMAX_BYTE_IO */
		i = CH375ByteWrite( );  /* ֽΪλļд,ζдĳȲܳMAX_BYTE_IO */
		mStopIfError( i );
		printf( "Write ADC data\n" );
		for ( hour = 8; hour != 20; hour ++  ) {  /* ѭʽ12 */
			TR0=1;  /* öʱ0ļֵADC */
			month = 5;  /* ٶ5 */
			date = TL1 & 0x1F;  /* Ϊ԰ûʵʱʱоƬ,öʱ1ļʾ */
/*			adc = get_adc_data( ); */
			adc = ( (UINT16)TH0 << 8 ) | TL0;  /* Ϊ԰ûADC,öʱ0ļADCʾ */
			len = sprintf( mCmdParam.ByteWrite.mByteBuffer, "%02d.%02d.%02d ADC=%u\xd\xa", (UINT16)month, date, (UINT16)hour, adc );  /* ݸʽΪһַ */
			mCmdParam.ByteWrite.mByteCount = (unsigned char)len;  /* ָдֽ,ܳMAX_BYTE_IO,ûֶд */
			i = CH375ByteWrite( );  /* ֽΪλļд,ζдĳȲܳMAX_BYTE_IO */
			mStopIfError( i );
		}
/*		mCmdParam.ByteWrite.mByteCount = 0;  ȫֱCH375LibConfigλ4Ϊ0,ָд0ֽ,ˢļĳ,
		CH375ByteWrite( );  ֽΪλļд,Ϊ0ֽд,ֻڸļĳ,׶дݺ,ְ취ļ
        ȫֱCH375LibConfigλ4Ϊ1,ÿдݺԶ޸/ļ,Ӷд0ֽ: CH375LibConfig |= 0x10; */
		printf( "Write end\n" );
		i = mCopyCodeStringToXRAM( mCmdParam.ByteWrite.mByteBuffer, "ADCݵ˽\xd\xa" );
		mCmdParam.ByteWrite.mByteCount = i;  /* ָдֽ,ζдĳȲܳMAX_BYTE_IO */
		i = CH375ByteWrite( );  /* ֽΪλļд,ζдĳȲܳMAX_BYTE_IO */
		mStopIfError( i );
/*		printf( "Modify\n" );  ʵʲƷʵʱʱ,ԸҪļںʱ޸Ϊʵֵ
		mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
		mCmdParam.Modify.mFileTime = MAKE_FILE_TIME( 16, 32, 09 );   : µļʱ: 16:32:09
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
		mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
		i = CH375FileModify( );   ޸ĵǰļϢ,޸
		mStopIfError( i );
*/
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
		i = CH375FileClose( );  /* رļ */
		mStopIfError( i );
		LED_WR_INACT( );
		LED_RUN_INACT( );
		printf( "Take out\n" );
		while ( CH375DiskStatus != DISK_DISCONNECT ) xQueryInterrupt( );  /* ѯCH375жϲж״̬,ȴṴγ */
		LED_OUT_INACT( );  /* LED */
		mDelaymS( 200 );
	}
}
